import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.software.PixelManipulator;
import it.unimi.dsi.pixelmanipulator.views.EditableGraphicalView;
import it.unimi.dsi.pixelmanipulator.views.GraphicalView;
import it.unimi.dsi.pixelmanipulator.views.RectangleView;

public class Main {
	    static private int width = 500;
	    static private int height = 200;
	    static final Display display = new Display();
	    static Shell shell = new Shell(display);
	
	public static void main(String[] args) {
		//initShell();
		//openPixelManipulator(PixelManipulator.MODE_STUDENT);
		run();
    }

    protected static void run() {
		//view window
		//shell.open();    	
    	
    	new PixelController(null, 2, shell);
    	
    	/*
		PixelModel model = new PixelModel();
		
		// vista modificabile
    	EditableGraphicalView ed = new EditableGraphicalView(model, shell, null, 2);
    	
    	// vista non modificabile
		//GraphicalView ed = new GraphicalView(model, shell);
		RectangleView rec = new RectangleView(model, shell, null, 2);
    	model.addObserver(ed);
    	model.addObserver(rec);
    	
    	// create image 
    	Image img = new Image(Display.getDefault(), 8, 10);
		ImageData data = img.getImageData();
		for (int x = 0; x < data.width; x++) {
		    for (int y = 0; y < data.height; y++) {
		    	data.setPixel(x, y, data.palette.getPixel(new RGB(0, 0, 0)));
		    }
		}
		model.setImage(data);		
		*/
		
		while (!shell.isDisposed()) {
		    if (!display.readAndDispatch())
			display.sleep();
		}
		display.dispose();
    }

    protected static void initShell() {
		shell.pack();
		shell.setText("Benvenuto in Pixel Manipulator!");
		shell.setLayout(new GridLayout(1, false));
		shell.setSize(width, height);
		shell.setLocation(
				  (int) ((shell.getDisplay().getBounds().width / 2) - (int) (width / 2)),
				  (int) ((shell.getDisplay().getBounds().height / 2) - (int) (height / 2)));
	
		addLabel();
		addButtons();
    }

    private static void addLabel() {
		GridData data = null;
		data = new GridData();
		data.grabExcessHorizontalSpace = true;
		data.heightHint = 30;
		data.horizontalAlignment = GridData.FILL;
	
		Label prompt_request = new Label(shell, SWT.PUSH | SWT.CENTER);
		prompt_request.setText("Selezionare la modalita' di avvio del software:");
		FontData[] fontData = prompt_request.getFont().getFontData();
		fontData[0].setStyle(SWT.BOLD);
		fontData[0].setHeight(15);
		prompt_request.setFont(new Font(shell.getDisplay(), fontData[0]));
		prompt_request.setLayoutData(data);
    }

    private static void addButtons() {
		GridData data = null;
		data = new GridData();
		data.grabExcessHorizontalSpace = true;
		data.horizontalAlignment = GridData.FILL;
		data.verticalAlignment = GridData.FILL;
		data.grabExcessVerticalSpace = true;
	
		Composite bottom = new Composite(shell, SWT.FILL);
	
		bottom.setBackground(new Color(null, new RGB(10, 10, 10)));
		bottom.setLayoutData(data);
		bottom.setLayout(new FillLayout());
	
		Button student = new Button(bottom, SWT.PUSH);
		student.setText("STUDENTE");
		student.addSelectionListener(new SelectionAdapter() {
				@Override
			    public void widgetSelected(SelectionEvent e) {
			    	openPixelManipulator(PixelManipulator.MODE_STUDENT);
				}
		});
			
		Button teacher = new Button(bottom, SWT.PUSH);
		teacher.setText("DOCENTE");
		teacher.addSelectionListener(new SelectionAdapter() {
				@Override
			    public void widgetSelected(SelectionEvent e) {
			    	openPixelManipulator(PixelManipulator.MODE_TEACHER);
				}
		});		
    }
    
    private static void openPixelManipulator( int mode ){
		//shell.dispose();
		new PixelManipulator(shell, mode);
    }
}