import java.io.IOException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import it.unimi.dsi.pixelmanipulator.software.PixelManipulator;

public class Main {
	static private int width = 1;
	static private int height = 1;
	static final Display display = new Display();
	static Shell shell = new Shell(display);

	public static void main(String[] args) {

//		initShell();
		openPixelManipulator(PixelManipulator.MODE_STUDENT);
		run();
	}

	protected static void run() {

//		shell.open();
		
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	protected static void initShell() {

		shell.pack();
//		shell.setText("Benvenuto in Pixel Manipulator!");
		shell.setLayout(new GridLayout(1, false));
		shell.setSize(width, height);
		shell.setLocation(
				(int) ((shell.getDisplay().getBounds().width / 2) - (int) (width / 2)),
				(int) ((shell.getDisplay().getBounds().height / 2) - (int) (height / 2)));

//		addLabel();
//		addButtons();

	}

	private static void addLabel() {
		GridData data = null;
		data = new GridData();
		data.grabExcessHorizontalSpace = true;
		data.heightHint = 30;
		data.horizontalAlignment = GridData.FILL;

		Label prompt_request = new Label(shell, SWT.PUSH | SWT.CENTER);
		prompt_request
				.setText("Selezionare la modalita' di avvio del software:");
		FontData[] fontData = prompt_request.getFont().getFontData();
		fontData[0].setStyle(SWT.BOLD);
		fontData[0].setHeight(15);
		prompt_request.setFont(new Font(shell.getDisplay(), fontData[0]));
		prompt_request.setLayoutData(data);
	}

	private static void addButtons() {
		GridData data = null;
		data = new GridData();
		data.grabExcessHorizontalSpace = true;
		data.horizontalAlignment = GridData.FILL;
		data.verticalAlignment = GridData.FILL;
		data.grabExcessVerticalSpace = true;

		Composite bottom = new Composite(shell, SWT.FILL);

		bottom.setBackground(new Color(null, new RGB(10, 10, 10)));
		bottom.setLayoutData(data);
		bottom.setLayout(new FillLayout());

		Button student = new Button(bottom, SWT.PUSH);
		student.setText("STUDENTE");
		student.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				openPixelManipulator(PixelManipulator.MODE_STUDENT);
			}
		});
		
		Button teacher = new Button(bottom, SWT.PUSH);
		teacher.setText("DOCENTE");
		teacher.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				openPixelManipulator(PixelManipulator.MODE_TEACHER);
			}
		});
		
	}
	private static void openPixelManipulator( int mode ){
		//shell.dispose();
		new PixelManipulator(shell, mode);
	}
}