package it.unimi.dsi.pixelmanipulator.model;

import java.util.Observable;

import org.eclipse.swt.graphics.ImageData;

public class PixelModel extends Observable {
	private ImageData image = null;
	private ImageData tmp = null;
	/**
	 * @uml.property  name="zoom"
	 */
	private int zoom = 30;

	public PixelModel() {
		super();
	}

	/**
	 * @return
	 * @uml.property  name="zoom"
	 */
	public int getZoom() {
		return zoom;
	}

	/**
	 * @param new_zoom
	 * @uml.property  name="zoom"
	 */
	public void setZoom(int new_zoom) {
		if (new_zoom > 0) {
			zoom = new_zoom;

			setChanged();
			notifyObservers();
		}
	}

	public PixelModel(ImageData newImage) {
		image = newImage;
		tmp = newImage;
	}

	public void setImage(ImageData newImage) {
		image = newImage;
		tmp = newImage;

		setChanged();
		notifyObservers();
	}

	public ImageData getCurrentImage() {
		return this.tmp.scaledTo(this.image.width * zoom, this.image.height
				* zoom);
	}

	public ImageData getImage() {
		return this.image;
	}
}
