package it.unimi.dsi.pixelmanipulator.software;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
//import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
//import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Shell;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.utils.GenericExercise;
//import it.unimi.dsi.pixelmanipulator.views.GraphicalView;

public class ConditionExerciseMode {
	final private Shell mainShell;
	/**
	 * @uml.property name="width"
	 */
	private int width = 300;
	/**
	 * @uml.property name="height"
	 */
	private int height = 100;
	private Shell shell;
	/**
	 * @uml.property name="colorsPalette" multiplicity="(0 -1)" dimension="1"
	 */
	String[] colorsPalette = new String[] { "Bianco e nero", "Toni di grigio",
			"RGB Primari e Secondari", "RGB Completi" };
	GenericExercise ex = null;

	public ConditionExerciseMode(Shell new_mainShell, GenericExercise gen_ex) {
		mainShell = new_mainShell;
		ex = gen_ex;
		shell = new Shell(new_mainShell, SWT.CLOSE);
		initShell();

		run();
	}

	protected void run() {
		mainShell.setVisible(false);
		shell.open();
		shell.addDisposeListener(new DisposeListener() {
			@Override
			public void widgetDisposed(DisposeEvent arg0) {
				mainShell.setVisible(true);
			}
		});
	}

	private void initShell() {
		shell.pack();
		shell.setText("Benvenuto in Pixel Manipulator - modalitEsercizio");
		shell.setLayout(new FillLayout(SWT.VERTICAL));
		shell.setSize(width, height);
		shell.setLocation(
				((shell.getDisplay().getBounds().width / 2) - (width / 2)),
				((shell.getDisplay().getBounds().height / 2) - (height / 2)));

		Button confirm = new Button(shell, SWT.PUSH); 	
		confirm.setText("Conferma");
		confirm.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				int tavolozza = 3;
				if (ex.getFeatures().get("track").compareTo("Ricostruzione") == 0) {
					if (ex.getFeatures().get("tavolozza")
							.compareTo("Bianco e nero") == 0) {
						tavolozza = 0;
					} else if (ex.getFeatures().get("tavolozza")
							.compareTo("Toni di grigio") == 0) {
						tavolozza = 1;
					} else if (ex.getFeatures().get("tavolozza")
							.compareTo("RGB Primari e Secondari") == 0) {
						tavolozza = 2;
					}

					PixelModel p = new PixelModel(ex.getData());
					new PixelController(p, tavolozza, shell,ex);
					p.setZoom(10);
				}
			}
		});
	}
}
