package it.unimi.dsi.pixelmanipulator.software;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Shell;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;

public class FreeExerciseMode {
	final private Shell mainShell;
	/**
	 * @uml.property  name="width"
	 */
	private int width = 300;
	/**
	 * @uml.property  name="height"
	 */
	private int height = 100;
	private Shell shell;
	/**
	 * @uml.property  name="colorsPalette" multiplicity="(0 -1)" dimension="1"
	 */
	String[] colorsPalette = new String[] { "Bianco e nero", "Toni di grigio",
			"RGB Primari e Secondari", "RGB Completi" };

	public FreeExerciseMode(Shell new_mainShell) {
		mainShell = new_mainShell;
//		shell = new Shell(new_mainShell, SWT.CLOSE);
//		initShell();
		new PixelController(null, 2, mainShell);
//		run();
	}

	protected void run() {
		mainShell.setVisible(false);
//		shell.open();
		shell.addDisposeListener(new DisposeListener() {
			@Override
			public void widgetDisposed(DisposeEvent arg0) {
				mainShell.setVisible(false);
			}
		});
	}

	private void initShell() {
		shell.pack();
//		shell.setText("Benvenuto in Pixel Manipulator - modalita' STUDENTE");
		shell.setLayout(new FillLayout(SWT.VERTICAL));
		shell.setSize(width, height);
		shell.setLocation(
				((shell.getDisplay().getBounds().width / 2) - (width / 2)),
				((shell.getDisplay().getBounds().height / 2) - (height / 2)));
		final Combo paletteExercise = new Combo(shell, SWT.PUSH);
		for (int i = 0; i < colorsPalette.length; i++) {
			paletteExercise.add(colorsPalette[i]);
		}
		Button confirm = new Button(shell, SWT.PUSH);
		confirm.setText("Conferma");
		confirm.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				new PixelController(null, paletteExercise.getSelectionIndex(), shell);
			}
		});
	}
}
