package it.unimi.dsi.pixelmanipulator.software;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;

//import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.utils.GenericExercise;

public class Student {
	final private Shell mainShell;
	/**
	 * @uml.property name="width"
	 */
	private int width = 300;
	/**
	 * @uml.property name="height"
	 */
	private int height = 100;
	private Shell shell;

	public Student(Shell new_mainShell) {
		mainShell = new_mainShell;
		shell = new Shell(new_mainShell, SWT.CLOSE);
		//initShell();
		new FreeExerciseMode(shell);
		run();
	}

	protected void run() {
		mainShell.setVisible(false);
		//shell.open();
		shell.addDisposeListener(new DisposeListener() {
			@Override
			public void widgetDisposed(DisposeEvent arg0) {
				mainShell.setVisible(false);
			}
		});
	}

	private void initShell() {
		shell.pack();
		shell.setText("Benvenuto in Pixel Manipulator - modalita' STUDENTE");
		shell.setLayout(new FillLayout());
		shell.setSize(width, height);
		shell.setLocation(
				((shell.getDisplay().getBounds().width / 2) - (width / 2)),
				((shell.getDisplay().getBounds().height / 2) - (height / 2)));
		Button openExercise = new Button(shell, SWT.PUSH);
		openExercise.setText("Apri esercizio");
		openExercise.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				FileDialog open = new FileDialog(shell, SWT.OPEN);
				open.setFilterExtensions(new String[] { "*.pxm" });
				String exerciseFile = open.open();
				if (exerciseFile != null) {
					GenericExercise ex = GenericExercise.open(exerciseFile);
					new ConditionExerciseMode(shell, ex);
				}
			}
		});

		Button freeExercise = new Button(shell, SWT.PUSH);
		freeExercise.setText("Modalita' libera");

		freeExercise.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				new FreeExerciseMode(shell);
			}
		});
	}
}
