package it.unimi.dsi.pixelmanipulator.software;

//import java.io.BufferedOutputStream;
import java.io.File;
//import java.io.FileOutputStream;
//import java.util.zip.ZipOutputStream;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import it.unimi.dsi.pixelmanipulator.utils.GenericExercise;

public class Teacher {
	/**
	 * @uml.property name="n_request"
	 */
	final int n_request = 2;
	final private Shell mainShell;
	/**
	 * @uml.property name="width"
	 */
	private int width = 500;
	/**
	 * @uml.property name="height"
	 */
	private int height = 500;
	private Shell shell;
	private Composite request1;
	private Composite request2;
	private Composite request3;
	private Composite request4A;
	private Composite request4B;
	private Composite request5B;
	private Composite request6B;
	private Composite salva;
	private Composite buttons;
	private GridData layoutData;
	private Combo typeExercise;
	private Button imageExercise;

	Text descriptionExercise;
	Text nameExercise;
	String fileName;
	
	Button matrix8ViewExercise;
	Button compressedViewExercise;
	Button matrixViewExercise;
	Button graphicViewExercise;
	Button rectangleViewExercise;

	Button matrix8_1ViewExercise;
	Button compressed_1ViewExercise;
	Button matrix_1ViewExercise;
	Button graphic_1ViewExercise;
	Button rectangle_1ViewExercise;

	/**
	 * @uml.property name="imageFile"
	 */
	private String imageFile;
	private ScrolledComposite sc;
	private Combo paletteExercise;
	Composite main;
	/**
	 * @uml.property name="colorsPalette" multiplicity="(0 -1)" dimension="1"
	 */
	String[] colorsPalette = new String[] { "Bianco e nero", "Toni di grigio",
			"RGB Primari e Secondari", "RGB Completi" };
	Text[] requestExercise = new Text[n_request];
	Text[][] requestOptions = new Text[n_request][4];

	public Teacher(Shell new_mainShell) {
		mainShell = new_mainShell;
		shell = new Shell(new_mainShell, SWT.CLOSE);
		initShell();
		run();
	}

	protected void run() {
		mainShell.setVisible(false);
		shell.open();
		shell.addDisposeListener(new DisposeListener() {
			@Override
			public void widgetDisposed(DisposeEvent arg0) {
				mainShell.setVisible(true);
			}
		});
	}

	protected void initShell() {
		shell.pack();
		shell.setText("Benvenuto in Pixel Manipulator - modalita' DOCENTE");
		shell.setLayout(new FillLayout());
		shell.setSize(width, height);
		shell.setLocation(
				((shell.getDisplay().getBounds().width / 2) - (width / 2)),
				((shell.getDisplay().getBounds().height / 2) - (height / 2)));
		sc = new ScrolledComposite(shell, SWT.BORDER | SWT.V_SCROLL);
		sc.setExpandHorizontal(true);
		sc.setExpandVertical(true);

		main = new Composite(sc, SWT.PUSH);
		sc.setContent(main);
		main.setLayout(new GridLayout(1, true));

		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;

		salva = new Composite(main, SWT.PUSH);
		request1 = new Composite(main, SWT.PUSH);
		request2 = new Composite(main, SWT.PUSH);
		request3 = new Composite(main, SWT.PUSH);
		request4A = new Composite(main, SWT.PUSH);
		request4B = new Composite(main, SWT.PUSH);
		request5B = new Composite(main, SWT.PUSH);
		request6B = new Composite(main, SWT.PUSH);
		buttons = new Composite(main, SWT.PUSH);

		request1.setVisible(true);
		request2.setVisible(true);
		request3.setVisible(false);
		request4A.setVisible(true);
		request4B.setVisible(true);
		request5B.setVisible(false);
		request6B.setVisible(false);
		salva.setVisible(false);
		buttons.setVisible(true);

		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;
		buttons.setLayoutData(layoutData);
		buttons.setLayout(new GridLayout(2, true));

		init_request1();
		init_request2();
		init_request3();
		initSalva();
	}

	private void initSalva()
	{
		salva.setLayout(new GridLayout(3, true));

		Button salva_esercizio = new Button(salva, SWT.PUSH);
		salva_esercizio.setText("SALVA");
		salva_esercizio.setLayoutData(layoutData);
		salva_esercizio.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				FileDialog save = new FileDialog(shell, SWT.SAVE);
				save.setFilterExtensions(new String[] { "*.pxm" });
				String fileNameS = save.open();
				GenericExercise ex = new GenericExercise(
						nameExercise.getText(), typeExercise
								.getItem(typeExercise.getSelectionIndex()),
						descriptionExercise.getText(), new File(fileName)) {
					@Override
					public void addExtra() {
						if (typeExercise.getSelectionIndex() == 0) {
							for( int i = 0 ; i < n_request; i++){
								addFeatures("domanda"+(i+1), requestExercise[i].getText());
								for( int j = 0; j < 4; j++){
									addFeatures("domanda"+(i+1)+"_risposta"+(j+1), requestOptions[i][j].getText());
								}
							}
						} else {
							addFeatures("tavolozza", paletteExercise.getItem(paletteExercise.getSelectionIndex()));
							if(matrix8ViewExercise!= null){
								if( matrix8ViewExercise.getSelection() && !matrix8_1ViewExercise.isEnabled()){
									addFeatures("matrix8View", "non_modificabile");
								}
								if( matrix8_1ViewExercise.getSelection() && !matrix8ViewExercise.isEnabled()){
									addFeatures("matrix8View", "modificabile");
								} 
							}
							// -----------------------------------------------
							if(compressedViewExercise!= null){
								if( compressedViewExercise.getSelection() && !compressed_1ViewExercise.isEnabled()){
									addFeatures("compressedView", "non_modificabile");
								}
								if( compressed_1ViewExercise.getSelection() && !compressedViewExercise.isEnabled()){
									addFeatures("compressedView", "modificabile");
								} 
							}
							// -----------------------------------------------
							if(matrixViewExercise!= null){
								if( matrixViewExercise.getSelection() && !matrix_1ViewExercise.isEnabled()){
									addFeatures("matrixView", "non_modificabile");
								}
								if( matrix_1ViewExercise.getSelection() && !matrixViewExercise.isEnabled()){
									addFeatures("matrixView", "modificabile");
								} 
							}
							// -----------------------------------------------
							if(graphicViewExercise!= null){
									if( graphicViewExercise.getSelection() && !graphic_1ViewExercise.isEnabled()){
									addFeatures("graphicView", "non_modificabile");
								}
								if( graphic_1ViewExercise.getSelection() && !graphicViewExercise.isEnabled()){
									addFeatures("graphicView", "modificabile");
								} 
							}
							// -----------------------------------------------
							if(rectangleViewExercise!= null){
								if( rectangleViewExercise.getSelection() && !rectangle_1ViewExercise.isEnabled()){
									addFeatures("rectangleView", "non_modificabile");
								}
								if( rectangle_1ViewExercise.getSelection() && !rectangleViewExercise.isEnabled()){
									addFeatures("rectangleView", "modificabile");
								} 
							}
						}
					}
				};
				ex.toArchive(fileNameS);
			}
		});
	}
	private void init_request1() {
		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;

		request1.setLayoutData(layoutData);
		request1.setLayout(new GridLayout(2, true));

		Label nameLabel = new Label(request1, SWT.NONE);
		nameLabel.setText("Nome esercizio");
		nameLabel.setLayoutData(layoutData);

		nameExercise = new Text(request1, SWT.NONE);
		nameExercise.setLayoutData(layoutData);
	}

	private void init_request2() {
		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;

		request2.setLayoutData(layoutData);
		request2.setLayout(new GridLayout(2, true));

		Label typeLabel = new Label(request2, SWT.NONE);
		typeLabel.setText("Tipologia esercizio");
		typeLabel.setLayoutData(layoutData);

		typeExercise = new Combo(request2, SWT.NONE);
		typeExercise.add("Interpretazione");
		typeExercise.add("Ricostruzione");
		typeExercise.setLayoutData(layoutData);

		typeListener();

	}

	private void init_request3() {
		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;
		layoutData.heightHint = 100;
		request3.setLayoutData(layoutData);

		request3.setLayout(new GridLayout(2, true));

		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.verticalAlignment = GridData.BEGINNING;
		layoutData.grabExcessHorizontalSpace = true;

		Label descriptionLabel = new Label(request3, SWT.NONE);
		descriptionLabel.setText("Traccia dell'esercizio");
		descriptionLabel.setLayoutData(layoutData);

		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.verticalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;
		layoutData.grabExcessVerticalSpace = true;

		descriptionExercise = new Text(request3, SWT.MULTI | SWT.V_SCROLL);
		descriptionExercise.setLayoutData(layoutData);

		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;

		Label imageLabel = new Label(request3, SWT.NONE);
		imageLabel.setText("Immagine da utilizzare");
		imageLabel.setLayoutData(layoutData);

		imageExercise = new Button(request3, SWT.NONE);
		imageExercise.setText("Apri...");
		imageExercise.setLayoutData(layoutData);
		imageListeners();
	}

	private void init_request4a() {

		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;
		request4A.setLayoutData(layoutData);
		request4A.setLayout(new GridLayout(2, true));
		for (int i = 0; i < n_request; i++) {

			Label requestLabel = new Label(request4A, SWT.NONE);
			requestLabel.setText("Testo della domanda n. " + (i + 1));
			requestLabel.setLayoutData(layoutData);

			requestExercise[i] = new Text(request4A, SWT.NONE);
			requestExercise[i].setLayoutData(layoutData);
			for (int j = 0; j < 4; j++) {

				Label requestOptionLabel = new Label(request4A, SWT.PUSH);
				requestOptionLabel.setText("Opzione " + (j + 1));
				requestOptionLabel.setLayoutData(new GridData(SWT.RIGHT,
						SWT.FILL, true, true, 1, 1));

				requestOptions[i][j] = new Text(request4A, SWT.NONE);
				requestOptions[i][j].setLayoutData(layoutData);
			}
		}

		salva.setVisible(true);
	}

	private void init_request4b() {
		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;
		request4B.setLayoutData(layoutData);

		request4B.setLayout(new GridLayout(2, true));
		Label requestLabel = new Label(request4B, SWT.NONE);
		requestLabel.setText("Selezionare una tavolozza");
		requestLabel.setLayoutData(layoutData);

		paletteExercise = new Combo(request4B, SWT.NONE);
		for (int i = 0; i < colorsPalette.length; i++) {
			paletteExercise.add(colorsPalette[i]);
		}
		paletteExercise.setLayoutData(layoutData);

		paletteListeners();

	}

	private void exclusiveButton(final Button a, final Button b) {

		a.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				b.setEnabled(!b.getEnabled());
			}
		});

		b.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				a.setEnabled(!a.getEnabled());
			}
		});

	}

	private void init_request5b_6b() {
		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;

		request5B.setLayoutData(layoutData);
		request5B.setLayout(new GridLayout(3, true));

		request6B.setLayoutData(layoutData);
		request6B.setLayout(new GridLayout(3, true));

		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;
		layoutData.horizontalSpan = 3;

		Label requestLabel = new Label(request5B, SWT.NONE);
		requestLabel.setText("Selezionare le formalizzazioni di aiuto");
		requestLabel.setLayoutData(layoutData);

		Label request1Label = new Label(request6B, SWT.NONE);
		request1Label.setText("Selezionare la formalizzazione modificabile");
		request1Label.setLayoutData(layoutData);
		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;

		if (paletteExercise.getSelectionIndex() == 0) {

		/*	matrix8ViewExercise = new Button(request5B, SWT.CHECK);
			matrix8ViewExercise.setText("Matrice a gruppi di 8 pixel");
			matrix8ViewExercise.setLayoutData(layoutData);*/

			compressedViewExercise = new Button(request5B, SWT.CHECK);
			compressedViewExercise.setText("Compressione semplice");
			compressedViewExercise.setLayoutData(layoutData);

			/*matrix8_1ViewExercise = new Button(request6B, SWT.CHECK);
			matrix8_1ViewExercise.setText("Matrice a gruppi di 8 pixel");
			matrix8_1ViewExercise.setLayoutData(layoutData);*/

			compressed_1ViewExercise = new Button(request6B, SWT.CHECK);
			compressed_1ViewExercise.setText("Compressione semplice");
			compressed_1ViewExercise.setLayoutData(layoutData);

			//exclusiveButton(matrix8ViewExercise, matrix8_1ViewExercise);
			exclusiveButton(compressedViewExercise, compressed_1ViewExercise);

		}
		matrixViewExercise = new Button(request5B, SWT.CHECK);
		matrixViewExercise.setText("Matrice");
		matrixViewExercise.setLayoutData(layoutData);

		graphicViewExercise = new Button(request5B, SWT.CHECK);
		graphicViewExercise.setText("Grafica");
		graphicViewExercise.setLayoutData(layoutData);

		 rectangleViewExercise = new Button(request5B, SWT.CHECK);
		rectangleViewExercise.setText("Compressione rettangoli");
		rectangleViewExercise.setLayoutData(layoutData);

		 matrix_1ViewExercise = new Button(request6B, SWT.CHECK);
		matrix_1ViewExercise.setText("Matrice");
		matrix_1ViewExercise.setLayoutData(layoutData);

		 graphic_1ViewExercise = new Button(request6B, SWT.CHECK);
		graphic_1ViewExercise.setText("Grafica");
		graphic_1ViewExercise.setLayoutData(layoutData);

		 rectangle_1ViewExercise = new Button(request6B, SWT.CHECK);
		rectangle_1ViewExercise.setText("Compressione rettangoli");
		rectangle_1ViewExercise.setLayoutData(layoutData);

		exclusiveButton(matrixViewExercise, matrix_1ViewExercise);
		exclusiveButton(graphicViewExercise, graphic_1ViewExercise);
		exclusiveButton(rectangleViewExercise, rectangle_1ViewExercise);

		layoutData = new GridData();
		layoutData.horizontalAlignment = GridData.FILL;
		layoutData.grabExcessHorizontalSpace = true;
		layoutData.horizontalSpan = 3;

		request5B.setVisible(true);
		request6B.setVisible(true);

		salva.setVisible(true);

		shell.pack();
		shell.setSize(width, height);
	}

	private void paletteListeners() {
		paletteExercise.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				init_request5b_6b();
				paletteExercise.setEnabled(false);
			}
		});
	}

	private void imageListeners() {
		imageExercise.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				FileDialog open = new FileDialog(shell, SWT.OPEN);
				open.setFilterExtensions(new String[] { "*.bmp" });
				fileName = open.open();
				if (fileName != null) {
					imageFile = fileName;
					final Shell previews = new Shell(shell, SWT.TITLE);
					previews.setLayout(new GridLayout());
					final ImageData imgData = new ImageData(imageFile)
							.scaledTo(300, 300);
					shell.addListener(SWT.Move, new Listener() {
						@Override
						public void handleEvent(Event e) {
							previews.setLocation(10 + shell.getLocation().x
									+ shell.getSize().x, shell.getLocation().y);
						}
					});
					previews.setLocation(
							10 + shell.getLocation().x + shell.getSize().x,
							shell.getLocation().y);
					previews.setSize(320, height);
					Canvas prev = new Canvas(previews, SWT.BORDER);
					GridData data = new GridData(GridData.CENTER,
							GridData.CENTER, true, true, 1, 1);
					data.widthHint = 300;
					data.heightHint = 300;
					prev.setLayoutData(data);
					prev.addPaintListener(new PaintListener() {
						@Override
						public void paintControl(PaintEvent e) {
							if (imgData != null) {
								Image img = new Image(mainShell.getDisplay(),
										imgData);
								e.gc.drawImage(img, 0, 0);
								img.dispose();
							}
						}
					});
					previews.open();
					switch (typeExercise.getSelectionIndex()) {
					case 0:
						init_request4a();
						request4B.dispose();
						break;
					case 1:
						init_request4b();
						request4A.dispose();
						break;
					default:
						break;
					}
					shell.pack();
					shell.setSize(width, height);
					imageExercise.setEnabled(false);
				}
			}
		});
	}

	private void typeListener() {
		typeExercise.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				typeExercise.setEnabled(false);
				request3.setVisible(true);
			}
		});

	}

}
