package it.unimi.dsi.pixelmanipulator.views;

//import java.awt.event.KeyAdapter;
//import java.util.ArrayList;
//import java.util.Iterator;
import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
//import org.eclipse.swt.events.MouseAdapter;
//import org.eclipse.swt.events.MouseEvent;
//import org.eclipse.swt.events.SelectionAdapter;
//import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
//import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
//import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
//import org.eclipse.swt.widgets.Button;
//import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
//import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
//import org.eclipse.swt.widgets.Table;
//import org.eclipse.swt.widgets.TableColumn;
//import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
//import it.unimi.dsi.pixelmanipulator.utils.Compression;
import it.unimi.dsi.pixelmanipulator.utils.CompressionBW;
//import it.unimi.dsi.pixelmanipulator.utils.MyRectangle;

public class CompressedView extends View implements Observer {

	private PixelModel image = null;
	Shell myShell = null;
	Text compressedString;
	CompressionBW comp;
	PixelController controller;

	public CompressedView(PixelModel new_image, Shell parent_Shell,
			PixelController new_controller) {
		image = new_image;
		controller = new_controller;
		image.addObserver(this);
		myShell = new Shell(parent_Shell);
		myShell.setLayout(new GridLayout(1, false));
		myShell.setText("Compressione semplice");
		initShell(500, 500);
		myShell.open();
	}

	public CompressedView(PixelModel new_image, Shell parent_Shell,
			PixelController new_controller, boolean editable) {
		image = new_image;
		controller = new_controller;
		image.addObserver(this);
		myShell = new Shell(parent_Shell);
		myShell.setLayout(new GridLayout(1, false));
		myShell.setText("Compressione semplice");
		initShell(500, 500);
		if( editable ){
			myShell.setBackground(new Color(null, new RGB(200,150,150)));
		}
		compressedString.setEditable(editable);
		myShell.open();
	}

	private void initShell(int width, int height) {
//		GridData data = null;
		myShell.pack();
		myShell.setSize(width, height);
		myShell.setLayout(new FillLayout());
		compressedString = new Text(myShell, SWT.BORDER | SWT.MULTI);
		FontData font[] = compressedString.getFont().getFontData();
		font[0].setHeight(20);
		Font g = new Font(Display.getDefault(), font[0]);
		compressedString.setFont(g);
		compressedString.addVerifyListener(new VerifyListener() {
			@Override
			public void verifyText(VerifyEvent e) {
				if (e.text.matches("([\\d_|])*")) {
				} else {
					e.text = "";
				}
			}
		});
		compressedString.addKeyListener(new KeyListener() {

			@Override
			public void keyReleased(KeyEvent e) {
				if (e.keyCode == SWT.CR) {
					comp.compressed = compressedString.getText();
					controller.setImage(comp.getImage());
				}
			}

			@Override
			public void keyPressed(KeyEvent arg0) {

			}
		});
	}

	@Override
	public void update(Observable arg0, Object arg1) {
		comp = new CompressionBW(image.getImage());
		compressedString.setText(comp.compressed);
	}
}