package it.unimi.dsi.pixelmanipulator.views;

import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Label;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.widgets.EditableCanvas;

public class EditableGraphicalView extends View implements Observer {
    /**
     * @uml.property  name="image"
     * @uml.associationEnd  multiplicity="(1 1)"
     */
    PixelModel image = null;
    /**
     * @uml.property  name="controller"
     * @uml.associationEnd  multiplicity="(1 1)"
     */
    PixelController controller;
    Shell myShell = null;
    /**
     * @uml.property  name="canvas"
     * @uml.associationEnd  multiplicity="(1 1)"
     */
    EditableCanvas canvas = null;
    ScrolledComposite scrolledComposite = null;
 
    static int DEFAULT_WINDOW_WIDTH = 320;
    static int DEFAULT_WINDOW_HEIGHT = 420;
    
    public EditableGraphicalView(PixelModel new_image, Shell parent_Shell,
				 PixelController new_controller, int palette) {
		controller = new_controller;
		image = new_image;
		//image.addObserver(this);
	
		/* finestra controllo */
		/*
		  Shell comands = new Shell(myShell, SWT.TITLE);
		  comands.setSize(600, 60);
		  comands.setLayout(new FillLayout());
			
		  GridData layoutData = new GridData();
		  layoutData.horizontalAlignment = GridData.FILL;
		  layoutData.verticalAlignment = GridData.FILL;
		  layoutData.grabExcessHorizontalSpace = true;
		  layoutData.grabExcessVerticalSpace = true;	
					
		  Composite buttons = new Composite(comands, SWT.PUSH);
		  buttons.setLayoutData(layoutData);
		  buttons.setLayout(new GridLayout(5, true));
		  //buttons.setLayout(new GridLayout(1, true));
			
			
		  Button zoomIN = new Button(buttons, SWT.PUSH);
		  zoomIN.setText("Zoom +");
		  zoomIN.setLayoutData(layoutData);
		  zoomIN.addSelectionListener(new SelectionAdapter() {
		  @Override
		  public void widgetSelected(SelectionEvent e) {
		  controller.zoomIn();
		  }
		  });
		  Button zoomOUT = new Button(buttons, SWT.PUSH);
		  zoomOUT.setText("Zoom -");
		  zoomOUT.setLayoutData(layoutData);
		  zoomOUT.addSelectionListener(new SelectionAdapter() {
		  @Override
		  public void widgetSelected(SelectionEvent e) {
		  controller.zoomOut();
		  }
		  });
		  Button flipH = new Button(buttons, SWT.PUSH);
		  flipH.setText("Rifletti orizzontalmente");
		  flipH.setLayoutData(layoutData);
		  flipH.addSelectionListener(new SelectionAdapter() {
		  @Override
		  public void widgetSelected(SelectionEvent e) {
		  controller.flipH();
		  }
		  });
		  Button flipV = new Button(buttons, SWT.PUSH);
		  flipV.setText("Rifletti verticalmente");
		  flipV.setLayoutData(layoutData);
		  flipV.addSelectionListener(new SelectionAdapter() {
		  @Override
		  public void widgetSelected(SelectionEvent e) {
		  controller.flipV();
		  }
		  });
			
		
		  comands.open();
		  /* fine finestra controllo */
			
		parent_Shell.setVisible(false);
		myShell = new Shell(parent_Shell, SWT.TITLE);
		myShell.setText("Vista modificabile");
		myShell.pack();
		myShell.setSize(DEFAULT_WINDOW_WIDTH, DEFAULT_WINDOW_HEIGHT);		
		myShell.setLocation(700,90);
		myShell.setLayout(new GridLayout(2, false));
			
		/* prima riga, prima colonna */ 
		new Label(myShell, SWT.None);
				
		/* prima riga, seconda colonna */ 
		Composite numbers = new Composite(myShell, SWT.SINGLE);		
		GridLayout l = new GridLayout(8, true);
		l.marginHeight = 1;
		l.marginLeft = 5;
		l.horizontalSpacing = 18;			
		numbers.setLayout(l);
		for (int i=0; i<=7; i++) {
		    Label lab = new Label(numbers, SWT.BORDER);
		    lab.setText(""+i);
		}
			
			
		/* seconda riga, prima colonna */ 
		String[] indexes= { "a", "b", "c", "d", "e", "f", "g", "h", "i", "j" };
		Composite letters = new Composite(myShell, SWT.SINGLE);		
		l = new GridLayout(1, false);
		l.verticalSpacing = 9;
		letters.setLayout(l);
		for (int i=0; i<10; i++) {
		    Label lab = new Label(letters, SWT.BORDER);
		    lab.setText(indexes[i]);
		}
			
		/* seconda riga, seconda colonna */ 
		GridData layoutData = new GridData();
		layoutData.heightHint = 280;
		layoutData.widthHint = 220;
		layoutData.horizontalIndent = 0;
		layoutData.verticalIndent = 0;		
		scrolledComposite = new ScrolledComposite(myShell, SWT.BORDER
							  | SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(layoutData);
		scrolledComposite.setLayout(new FillLayout());
		canvas = new EditableCanvas(scrolledComposite, SWT.PUSH,
					    image.getZoom(), controller, palette);
		scrolledComposite.setContent(canvas);
			
		/* terza riga, prima colonna */
		new Label(myShell, SWT.None);
			
		/* terza riga, seconda colonna */
		Composite changeColors = new Composite(myShell, SWT.SINGLE);
		changeColors.setLayout(new GridLayout(2, true));
		new Label(changeColors, SWT.None).setText("Colore:");
			
		final Combo color = new Combo(changeColors, SWT.PUSH);
		switch (palette) {
		case PixelController.BW:
		    color.add("0");
		    color.add("1");	
		    break;
		case PixelController.GRAYSCALE:
		    color.add("0");
		    color.add("1");	
		    color.add("2");
		    color.add("3");	
		    color.add("4");
		    color.add("5");	
		    break;
		case PixelController.RGB6:
		    color.add("Rosso");
		    color.add("Verde");
		    color.add("Blu");
		    color.add("Azzurro");
		    color.add("Giallo");
		    color.add("Viola");
		    // add bianco e nero
		    color.add("Nero");
		    color.add("Bianco");
		default:
		    break;
		}
		color.select(0);
		
		color.addSelectionListener(new SelectionAdapter() {
			@Override
			    public void widgetSelected(SelectionEvent e) {
			    canvas.setColor(color.getSelectionIndex());
			}
		    });
			
		/* active shell */
		myShell.open();
    }

    @Override
	public void update(Observable o, Object arg) {
	ImageData img = image.getCurrentImage();
	if (img != null) {
	    canvas.zoom = image.getZoom();
	    canvas.setSize(img.width, img.height);
	    canvas.setImage(new Image(myShell.getDisplay(), img));
	}
    }
}
