package it.unimi.dsi.pixelmanipulator.views;

import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.widgets.EditableCanvas;

@SuppressWarnings("unused")
public class EditableGraphicalView extends View implements Observer {
	/**
	 * @uml.property  name="image"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	PixelModel image = null;
	/**
	 * @uml.property  name="controller"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	PixelController controller;
	Shell myShell = null;
	/**
	 * @uml.property  name="canvas"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	EditableCanvas canvas = null;
	ScrolledComposite scrolledComposite = null;
	
    static int DEFAULT_WINDOW_WIDTH = 300;
    static int DEFAULT_WINDOW_HEIGHT = 380;
	
	public EditableGraphicalView(PixelModel new_image, Shell parent_Shell,
			PixelController new_controller, int palette) {
		controller = new_controller;
		image = new_image;
		image.addObserver(this);

		myShell = new Shell(parent_Shell, SWT.TITLE);
		myShell.setLocation(400,90);
		myShell.setLayout(new GridLayout(1, true));
		myShell.setText("Vista Pixel (non modificabile)");
		myShell.setSize(DEFAULT_WINDOW_WIDTH, DEFAULT_WINDOW_HEIGHT);
		
	    
		GridData layoutData = new GridData();
		
		myShell.setLayout(new GridLayout(2, false));
		
		/* prima riga, prima colonna */ 
		new Label(myShell, SWT.None);
				
		/* prima riga, seconda colonna */ 
		Composite numbers = new Composite(myShell, SWT.SINGLE);		
		GridLayout l = new GridLayout(8, true);
		l.marginHeight = 1;
		l.marginLeft = 4;
		l.horizontalSpacing = 18;			
		numbers.setLayout(l);
		for (int i=0; i<=7; i++) {
		    Label lab = new Label(numbers, SWT.BORDER);
		    lab.setText(""+i);
		}
			
			
		/* seconda riga, prima colonna */ 
		String[] indexes= { "a", "b", "c", "d", "e", "f", "g", "h", "i", "j" , "k" , "l" };
		Composite letters = new Composite(myShell, SWT.SINGLE);		
		l = new GridLayout(1, false);
		l.verticalSpacing = 9;
		letters.setLayout(l);
		for (int i=0; i<10; i++) {
		    Label lab = new Label(letters, SWT.BORDER);
		    lab.setText(indexes[i]);
		}
		
		/* seconda riga, seconda colonna */
		layoutData = new GridData();
		layoutData.heightHint = 280;
		layoutData.widthHint = 220;
		layoutData.horizontalIndent = 0;
		layoutData.verticalIndent = 0;	

		scrolledComposite = new ScrolledComposite(myShell, SWT.BORDER
				| SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(layoutData);
		scrolledComposite.setLayout(new FillLayout());
		canvas = new EditableCanvas(scrolledComposite, SWT.PUSH,
				image.getZoom(), controller, palette);
		scrolledComposite.setContent(canvas);
		myShell.open();
	}

	@Override
	public void update(Observable o, Object arg) {
		ImageData img = image.getCurrentImage();
		if (img != null) {
			canvas.zoom = image.getZoom();
			canvas.setSize(img.width, img.height);
			canvas.setImage(new Image(myShell.getDisplay(), img));
		}
	}
}
