package it.unimi.dsi.pixelmanipulator.views;

import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Shell;

import it.unimi.dsi.pixelmanipulator.model.PixelModel;
//import it.unimi.dsi.pixelmanipulator.utils.Compression;

public class GraphicalView extends View implements Observer {
	/**
	 * @uml.property  name="image"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	final PixelModel image;
	Shell myShell = null;
	Canvas canvas = null;
	ScrolledComposite scrolledComposite = null;

	public GraphicalView(PixelModel new_image, Shell parent_Shell) {

		image = new_image;
		image.addObserver(this);

		myShell = new Shell(parent_Shell, SWT.TITLE);
		myShell.setLayout(new FillLayout());
		myShell.pack();
		myShell.setSize(500, 500);

		scrolledComposite = new ScrolledComposite(myShell, SWT.BORDER
				| SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayout(new FillLayout());

		canvas = new Canvas(scrolledComposite, SWT.PUSH);
		canvas.addPaintListener(new PaintListener() {
			@Override
			public void paintControl(PaintEvent evt) {
				System.out.println("ooo");
				if (image.getCurrentImage() != null) {
					int gray = 215;
					Image img = new Image(myShell.getDisplay(), image
							.getCurrentImage());
					int width = img.getImageData().width, height = img
							.getImageData().height, zoom = image.getZoom();
					evt.gc.drawImage(img, 0, 0);
					img.dispose();
					for (int i = 0; i < width / zoom; i++) {
						evt.gc.setForeground(new Color(null, new RGB(gray,
								gray, gray)));
						evt.gc.drawLine(i * zoom, 0, i * zoom, height);
					}

					for (int i = 0; i < height / zoom; i++) {
						evt.gc.setForeground(new Color(null, new RGB(gray,
								gray, gray)));
						evt.gc.drawLine(0, i * zoom, width, i * zoom);
					}

				}
			}
		});
		scrolledComposite.setContent(canvas);
		myShell.open();
	}

	@Override
	public void update(Observable o, Object arg) {
		ImageData img = image.getCurrentImage();
//		Compression c = new Compression(img);
		if (img != null) {
			canvas.setSize(img.width, img.height);
		}
		canvas.redraw();
	}
}