package it.unimi.dsi.pixelmanipulator.views;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
//import org.eclipse.swt.custom.TableEditor;
//import org.eclipse.swt.events.FocusAdapter;
//import org.eclipse.swt.events.FocusEvent;
//import org.eclipse.swt.events.KeyAdapter;
//import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
//import org.eclipse.ui.internal.Model;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.utils.Compression;
import it.unimi.dsi.pixelmanipulator.utils.MyRectangle;

public class RectangleView extends View implements Observer {

	private PixelModel image = null;
	Shell myShell = null;
	int selected_row = -1;
	Table rectangles;
	Compression c;
	boolean can_edit = false;
	
	// Indice delle righe
	public static String[] alphabet = { "a", "b", "c", "d", "e", "f", "g",
		"h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t",
		"u", "v", "w", "x", "y", "z" };
	
	// Dimensione dell'immagine
	final int max_X_img = 10;
	final int max_Y_img = 10;
	
	// Matrice dei pixel usati
	boolean[][] pixelUsed = new boolean[max_X_img][max_Y_img];
	
	ArrayList<MyRectangle> list, tmp_list;
	final int type_of_colors;
	
	// Dimensione della finestra
	final int shell_width = 400;
	final int shell_height = 500;
	
	// Colore di inizializzazione dell'immagine (grigio)
	final RGB null_color = new RGB(200,200,200);

	
	final RGB[][] colors = new RGB[][] {
			new RGB[] { new RGB(255, 255, 255), new RGB(0, 0, 0) },
			new RGB[] { new RGB(255, 255, 255), new RGB(192, 192, 192),
					new RGB(144, 144, 144), new RGB(96, 96, 96),
					new RGB(48, 48, 48), new RGB(0, 0, 0) },
			new RGB[] { new RGB(255, 0, 0), new RGB(0, 255, 0),
					new RGB(0, 0, 255), new RGB(0, 255, 255),
					new RGB(255, 255, 0), new RGB(255, 0, 255),
					new RGB(255, 255, 255), new RGB(0, 0, 0)} };
	PixelController controller;

	public RectangleView(PixelModel new_image, Shell parent_Shell,
			PixelController new_controller, int palette) {
		
		pixelUsed = inizializePixelMatrix(max_X_img,max_Y_img);
		
		image = new_image;
		controller = new_controller;
		type_of_colors = palette;
		image.addObserver(this);
		myShell = new Shell(parent_Shell);
		myShell.setLayout(new GridLayout(1, false));
		myShell.setText("Compressione rettangoli");
	    myShell.setLocation(0,90);
		initShell(shell_width,shell_height);
		myShell.open();
	}

	public RectangleView(PixelModel new_image, Shell parent_Shell,
			PixelController new_controller, int palette, boolean editable) {
		
		pixelUsed = inizializePixelMatrix(max_X_img,max_Y_img);
		
		image = new_image;
		controller = new_controller;
		can_edit = editable;
		type_of_colors = palette;
		image.addObserver(this);
		myShell = new Shell(parent_Shell);
		myShell.setLayout(new GridLayout(1, false));
		myShell.setText("Compressione rettangoli");
	    myShell.setLocation(0,90);
		if( editable ){
			myShell.setBackground(new Color(null, new RGB(200,150,150)));
		}
		initShell(shell_width,shell_height);
		myShell.open();
	}

	private void initShell(int width, int height) {
		GridData data = null;
		can_edit = true;
		myShell.pack();
		myShell.setSize(width, height);

		Composite top_label = new Composite(myShell, SWT.FILL);
		data = new GridData();
		data.grabExcessHorizontalSpace = true;
		data.heightHint = 20;
//		data.widthHint = 300;
		data.horizontalAlignment = GridData.FILL;
		top_label.setLayoutData(data);
		top_label.setLayout(new GridLayout(5, false));
		
		Composite top = new Composite(myShell, SWT.FILL);
		data = new GridData();
		data.grabExcessHorizontalSpace = true;
		data.heightHint = 35;
//		data.widthHint = 300;
		data.horizontalAlignment = GridData.FILL;
		top.setLayoutData(data);
		top.setLayout(new GridLayout(5, false));
		
		/*
		 * Form rectangle data
		 */
		data = new GridData();
		Label labelL = new Label(top_label, SWT.NONE);
		labelL.setText("        X0    ");
		labelL.setLayoutData(data);
		final Text L = new Text(top, SWT.FILL);
		data = new GridData();
		data.verticalAlignment = GridData.FILL;
		L.setLayoutData(data);

		data = new GridData();
		Label labelT = new Label(top_label, SWT.NONE);
		labelT.setText("        Y0    ");
		labelT.setLayoutData(data);
		final Text T = new Text(top, SWT.FILL);
		data = new GridData();
		data.verticalAlignment = GridData.FILL;
		T.setLayoutData(data);

		data = new GridData();
		Label labelR = new Label(top_label, SWT.NONE);
		labelR.setText("        X1     ");
		labelR.setLayoutData(data);
		final Text R = new Text(top, SWT.FILL);
		data = new GridData();
		data.verticalAlignment = GridData.FILL;
		R.setLayoutData(data);

		data = new GridData();
		Label labelB = new Label(top_label, SWT.NONE);
		labelB.setText("        Y1     ");
		labelB.setLayoutData(data);
		final Text B = new Text(top, SWT.FILL);
		data = new GridData();
		data.verticalAlignment = GridData.FILL;
		B.setLayoutData(data);

		data = new GridData();
		Label color = new Label(top_label, SWT.NONE);
		color.setText("      Colore ");
		color.setLayoutData(data);
		final Combo C = new Combo(top, SWT.PUSH);
		if (true) {
//		if (can_edit) {
			switch (type_of_colors) {
			case PixelController.BW:
				C.add("0");
				C.add("1");
				break;
			case PixelController.GRAYSCALE:
				C.add("0");
				C.add("1");
				C.add("2");
				C.add("3");
				C.add("4");
				C.add("5");
				break;
			case PixelController.RGB6:
				C.add("Rosso"); // Rosso 
				C.add("Verde"); // Verde
				C.add("Blu"); // Blu
				C.add("Azzurro"); // Azzurro
				C.add("Giallo"); // Giallo
				C.add("Viola"); // Viola
				C.add("Bianco"); // Nero
				C.add("Nero"); // Bianco
			default:
				break;
			}
			C.select(0);
			data = new GridData();
			data.verticalAlignment = GridData.FILL;
			data.grabExcessHorizontalSpace = true;
			C.setLayoutData(data);
		}
		
		Button del = null, add = null, confirm= null;
		data = new GridData();
		data.verticalAlignment = GridData.FILL;//CENTER;
		data.horizontalAlignment = GridData.CENTER;
		Composite but = new Composite(myShell, SWT.FILL);
		data.heightHint = 35;
		but.setLayoutData(data);
		but.setLayout(new GridLayout(4, false));
		add = new Button(but, SWT.NONE);
		data = new GridData();
		data.verticalAlignment = GridData.FILL;//CENTER;
		data.horizontalAlignment = GridData.CENTER;
		add.setText("Aggiungi");
		add.setLayoutData(data);
		del = new Button(but, SWT.NONE);
		del.setText("Rimuovi");
		del.setLayoutData(data);

		Composite bottom = new Composite(myShell, SWT.FILL);
		data = new GridData();
		data.grabExcessHorizontalSpace = true;
		data.horizontalAlignment = GridData.FILL;
		data.verticalAlignment = GridData.FILL;
		data.grabExcessVerticalSpace = true;
		bottom.setLayout(new FillLayout());
		rectangles = new Table(bottom, SWT.FULL_SELECTION | SWT.FILL | SWT.VIRTUAL );
		rectangles.setHeaderVisible(true);
		String[] headers = new String[] { "X0", "Y0", "X1", "Y1", "Colore" };
		for (int i = 0; i < headers.length; i++) {
			TableColumn column = new TableColumn(rectangles, SWT.NONE);
			column.setText(headers[i]);
			column.setResizable(false);
			column.setMoveable(false);
//			column.setWidth((width - 20) / headers.length);
			column.setWidth(25);
			column.setAlignment(1);
		}
		bottom.setLayoutData(data);

		rectangles.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
				Point click = new Point(e.x, e.y);
				TableItem item = rectangles.getItem(click);
				System.out.println("selezionato_1");
				if (item != null) {
					selected_row = rectangles.indexOf(item);
					L.setText(item.getText(0));
					T.setText(item.getText(1));
					R.setText(item.getText(2));
					B.setText(item.getText(3));
				}
			}
		});
		add.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
//				if (selected_row >= 0) {
//					System.out.println("add_sel_1");
//					MyRectangle tmp = tmp_list.get(selected_row);					
//					tmp.L = Integer.parseInt(L.getText());
//					tmp.T = Integer.parseInt(T.getText());
//					tmp.R = Integer.parseInt(R.getText());
//					tmp.B = Integer.parseInt(B.getText());
//					tmp.C = colors[type_of_colors][C.getSelectionIndex()];
//					list.set(selected_row, tmp);
//					tmp_list.set(selected_row, tmp);
//					System.out.println(list);
//					controller.setImage(c.getImage());
//					;
//				}
//				else {
					if (!(L.getText().isEmpty()) && !(T.getText().isEmpty()) && !(R.getText().isEmpty()) && !(B.getText().isEmpty())){
						MyRectangle tmp = new MyRectangle();
						try {
							System.out.println(T.getText());
							System.out.println(B.getText());
							int Tindex = java.util.Arrays.asList(alphabet).indexOf(T.getText());
							int Bindex = java.util.Arrays.asList(alphabet).indexOf(B.getText());
							if ((Integer.parseInt(L.getText()) < max_X_img) && 
								(Integer.parseInt(R.getText()) < max_X_img) && 
								(Tindex < max_X_img) && 
//								(Integer.parseInt(T.getText()) < max_Y_img) && 
//								(Integer.parseInt(B.getText()) < max_Y_img) && 
								(Bindex < max_Y_img) && 
								(Integer.parseInt(L.getText()) <= Integer.parseInt(R.getText())) && 
								(Tindex <= Bindex)){
//								(Integer.parseInt(T.getText()) <= Integer.parseInt(B.getText()))){
									tmp.L = Integer.parseInt(L.getText());
									tmp.T = Tindex;
//									tmp.T = Integer.parseInt(T.getText());
									tmp.R = Integer.parseInt(R.getText());
//									tmp.B = Integer.parseInt(B.getText());
									tmp.B = Bindex;
									tmp.C = colors[type_of_colors][C.getSelectionIndex()];
									if (integrityPixelMatrixCheck(pixelUsed,tmp)){
										pixelUsed = setPixelMatrix(pixelUsed,tmp);
										list.add(tmp);
										tmp_list.add(tmp);
										System.out.println(list);
										controller.setImage(c.getImage());
									}
									else {
										MessageBox messageBox = new MessageBox(myShell, SWT.ICON_ERROR |  
											       SWT.OK);
										messageBox.setText("ATTENZIONE!!!");
										messageBox.setMessage("Il rettangolo che si vuole inserire si sovrappone ad un altro rettangolo già inserito!!\nModificare le coordinate dei vertici e riprovare...");
										messageBox.open();
									}
							}
							else {
								MessageBox messageBox = new MessageBox(myShell, SWT.ICON_ERROR |  
									       SWT.OK);
								messageBox.setText("ATTENZIONE!!!");
								messageBox.setMessage("Coordinate inserite non valide...\nRicontrollare i valori e riprovare...");
								messageBox.open();
							}
						}
//						catch (java.lang.NumberFormatException e1){
						catch (Exception e1){
							MessageBox messageBox = new MessageBox(myShell, SWT.ICON_ERROR |  
							       SWT.OK);
							messageBox.setText("ATTENZIONE!!!");
							messageBox.setMessage("Coordinate inserite non valide...\nRicontrollare i valori e riprovare...");
							messageBox.open();
						}
				}
			}
			});
			del.addSelectionListener(new SelectionAdapter() {
				@Override
				public void widgetSelected(SelectionEvent e) {
					if (selected_row >= 0) {
						if (tmp_list.size() > 0) {
							System.out.println("del_sel_0");
							System.out.println(selected_row);
							MyRectangle tmp = tmp_list.get(selected_row);
							int Tindex = java.util.Arrays.asList(alphabet).indexOf(T.getText());
							int Bindex = java.util.Arrays.asList(alphabet).indexOf(B.getText());
							tmp.L = Integer.parseInt(L.getText());
							tmp.T = Tindex;
							tmp.R = Integer.parseInt(R.getText());
							tmp.B = Bindex;
							tmp.C = null_color;
							pixelUsed = unsetPixelMatrix(pixelUsed,tmp);
							list.add(tmp);
							tmp_list.remove(selected_row);
							System.out.println(list);
							controller.setImage(c.getImage());
						}
					}
				}
			});
	}
	
	// inizializza la matrice che memorizza i pixel colorati
	public boolean[][] inizializePixelMatrix(int maxX, int maxY){
		boolean[][] pixelMatrix = new boolean[maxX][maxY]; 
		for(int x = 0; x<maxX ; x++){
			for(int y = 0; y<maxY ; y++){
				pixelMatrix[x][y] =  false;
				}
			}
		
		return pixelMatrix;
		}
	
	// verifica che i pixer del riquadro corrente non siano già stati assegnati ad altri riquadri
	public boolean integrityPixelMatrixCheck(boolean[][] pixel_used, MyRectangle newRect){
		for(int x = newRect.L; x<=newRect.R ; x++){
			for(int y = newRect.T; y<=newRect.B ; y++){
				if (pixel_used[x][y] == true){
					return false;
				}}
			}
		return true;
	}
	
	// setta i pixel come usati
	public boolean[][] setPixelMatrix(boolean[][] pixel_used, MyRectangle newRect){
		for(int x = newRect.L; x<=newRect.R ; x++){
			for(int y = newRect.T; y<=newRect.B ; y++){
				pixel_used[x][y] =  true;
				}
			}
		return pixel_used;
	}
	
	// unsetta i pixel come usati
	public boolean[][] unsetPixelMatrix(boolean[][] pixel_used, MyRectangle newRect){
		for(int x = newRect.L; x<=newRect.R ; x++){
			for(int y = newRect.T; y<=newRect.B ; y++){
				pixel_used[x][y] =  false;
				}
			}
		return pixel_used;
	}
	
	@Override
	public void update(Observable o, Object arg) {
		rectangles.removeAll();
		c = new Compression(image.getImage());
		try {
			System.out.println("Before");
			System.out.println(list);
			System.out.println(tmp_list);
			list = c.list;
			System.out.println("After");
			System.out.println(list);
			Iterator<MyRectangle> i = tmp_list.iterator();
			while (i.hasNext()) {
				MyRectangle tmp = i.next();
				if (tmp.C != null_color){
					TableItem item = new TableItem(rectangles, SWT.NONE);
					item.setBackground(4, new Color(myShell.getDisplay(), tmp.C));
//					String[] dataItem = { tmp.L + "", tmp.T + "", tmp.R + "",
//						tmp.B + "" };
					String[] dataItem = { tmp.L + "", alphabet[tmp.T] + "", tmp.R + "",
							alphabet[tmp.B] + "" };
					item.setText(dataItem);
					}
		}} catch (java.lang.NullPointerException e) {
			System.out.println("Exception raised");
			list = c.list;
			tmp_list = list;
//			tmp_list.remove(0);
			Iterator<MyRectangle> i = tmp_list.iterator();
			while (i.hasNext()) {
				MyRectangle tmp = i.next();
				if (tmp.C != null_color){
					TableItem item = new TableItem(rectangles, SWT.NONE);
					item.setBackground(4, new Color(myShell.getDisplay(), tmp.C));
//					String[] dataItem = { tmp.L + "", tmp.T + "", tmp.R + "",
//							tmp.B + "" };
					String[] dataItem = { tmp.L + "", alphabet[tmp.T] + "", tmp.R + "",
							alphabet[tmp.B] + "" };
					item.setText(dataItem);
					}
			};
			MyRectangle tmp = new MyRectangle();					
			tmp.L = 0;
			tmp.T = 0;
			tmp.R = 7;
			tmp.B = 9;
			tmp.C = null_color;
			list.add(tmp);
			controller.setImage(c.getImage());
			tmp_list.remove(0);
			}
		
	}
}
