package it.unimi.dsi.pixelmanipulator.views;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
//import org.eclipse.swt.custom.TableEditor;
//import org.eclipse.swt.events.FocusAdapter;
//import org.eclipse.swt.events.FocusEvent;
//import org.eclipse.swt.events.KeyAdapter;
//import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
//import org.eclipse.ui.internal.Model;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.utils.Compression;
import it.unimi.dsi.pixelmanipulator.utils.MyRectangle;

public class RectangleView extends View implements Observer {
    
    static int DEFAULT_WINDOW_HEIGHT = 600 ;
    
    private PixelModel image = null;
    Shell myShell = null;
    int selected_row = -1;
    Table rectangles;
    Compression c;
    boolean can_edit = false;
    ArrayList<MyRectangle> list;
    final int type_of_colors;
    final RGB[][] colors = new RGB[][] {
	new RGB[] { new RGB(255, 255, 255), new RGB(0, 0, 0) },
	new RGB[] { new RGB(255, 255, 255), new RGB(192, 192, 192),
		    new RGB(144, 144, 144), new RGB(96, 96, 96),
		    new RGB(48, 48, 48), new RGB(0, 0, 0) },
	new RGB[] { new RGB(255, 0, 0), new RGB(0, 255, 0),
		    new RGB(0, 0, 255), new RGB(0, 255, 255),
		    new RGB(255, 255, 0), new RGB(255, 0, 255) } };
    PixelController controller;

    public RectangleView(PixelModel new_image, Shell parent_Shell,
			 PixelController new_controller, int palette) {
	image = new_image;
	controller = new_controller;
	type_of_colors = palette;
	image.addObserver(this);
	myShell = new Shell(parent_Shell);
	myShell.setLayout(new GridLayout(1, false));
	myShell.setLocation(200,90);
	myShell.setText("Compressione rettangoli");
	initShell(DEFAULT_WINDOW_WIDTH, DEFAULT_WINDOW_HEIGHT);
	myShell.open();
    }

    public RectangleView(PixelModel new_image, Shell parent_Shell,
			 PixelController new_controller, int palette, boolean editable) {
	image = new_image;
	controller = new_controller;
	can_edit = editable;
	type_of_colors = palette;
	image.addObserver(this);
	myShell = new Shell(parent_Shell);
	myShell.setLayout(new GridLayout(1, false));
	myShell.setLocation(820,90);
	myShell.setText("Compressione rettangoli");
	if( editable ){
	    myShell.setBackground(new Color(null, new RGB(200,150,150)));
	}
	initShell(DEFAULT_WINDOW_WIDTH, DEFAULT_WINDOW_HEIGHT);
	myShell.open();
    }

    private void initShell(int width, int height) {
	GridData data = null;

	myShell.pack();
	myShell.setSize(width, height);
/*
	Composite top = new Composite(myShell, SWT.FILL);
	data = new GridData();
	data.grabExcessHorizontalSpace = true;
	data.heightHint = 50;
	data.horizontalAlignment = GridData.FILL;
	top.setLayoutData(data);
	top.setLayout(new GridLayout(10, false));
	/*
	 * Form rectangle data
	 */
/*
	data = new GridData();
	Label labelL = new Label(top, SWT.NONE);
	labelL.setText("L: ");
	labelL.setLayoutData(data);
	final Text L = new Text(top, SWT.FILL);
	data = new GridData();
	data.verticalAlignment = GridData.FILL;
	L.setLayoutData(data);

	data = new GridData();
	Label labelT = new Label(top, SWT.NONE);
	labelT.setText("T: ");
	labelT.setLayoutData(data);
	final Text T = new Text(top, SWT.FILL);
	data = new GridData();
	data.verticalAlignment = GridData.FILL;
	T.setLayoutData(data);

	data = new GridData();
	Label labelR = new Label(top, SWT.NONE);
	labelR.setText("R: ");
	labelR.setLayoutData(data);
	final Text R = new Text(top, SWT.FILL);
	data = new GridData();
	data.verticalAlignment = GridData.FILL;
	R.setLayoutData(data);

	data = new GridData();
	Label labelB = new Label(top, SWT.NONE);
	labelB.setText("B: ");
	labelB.setLayoutData(data);
	final Text B = new Text(top, SWT.FILL);
	data = new GridData();
	data.verticalAlignment = GridData.FILL;
	B.setLayoutData(data);

	data = new GridData();
	Label color = new Label(top, SWT.NONE);
	color.setText("Color: ");
	color.setLayoutData(data);
	final Combo C = new Combo(top, SWT.PUSH);
	if (can_edit) {
	    switch (type_of_colors) {
	    case PixelController.BW:
		C.add("0");
		C.add("1");
		break;
	    case PixelController.GRAYSCALE:
		C.add("0");
		C.add("1");
		C.add("2");
		C.add("3");
		C.add("4");
		C.add("5");
		break;
	    case PixelController.RGB6:
		C.add("<1,0,0>");
		C.add("<0,1,0>");
		C.add("<0,0,1>");
		C.add("<0,1,1>");
		C.add("<1,1,0>");
		C.add("<1,0,1>");
	    default:
		break;
	    }
	    C.select(0);
	    data = new GridData();
	    data.verticalAlignment = GridData.FILL;
	    data.grabExcessHorizontalSpace = true;
	    C.setLayoutData(data);

	    C.addSelectionListener(new SelectionAdapter() {
		    @Override
			public void widgetSelected(SelectionEvent e) {
			if (selected_row >= 0) {
			    MyRectangle tmp = list.get(selected_row);
			    tmp.C = colors[type_of_colors][C.getSelectionIndex()];
			    list.set(selected_row, tmp);
			    controller.setImage(c.getImage());
			}
		    }
		});
	}
	Button del = null, add = null;
	if (can_edit) {
	    add = new Button(top, SWT.NONE);
	    data = new GridData();
	    add.setText("+");
	    add.setLayoutData(data);

	    del = new Button(top, SWT.NONE);
	    data = new GridData();
	    del.setText("-");
	    del.setLayoutData(data);
	}
*/
	Composite bottom = new Composite(myShell, SWT.FILL);
	data = new GridData();
	data.grabExcessHorizontalSpace = true;
	data.horizontalAlignment = GridData.FILL;
	data.verticalAlignment = GridData.FILL;
	data.grabExcessVerticalSpace = true;
	bottom.setLayout(new FillLayout());
	rectangles = new Table(bottom, SWT.FULL_SELECTION | SWT.FILL);
	rectangles.setHeaderVisible(true);
	String[] headers = new String[] { "LTx", "LTy", "RBx", "RBy", "Color" };
	for (int i = 0; i < headers.length; i++) {
	    TableColumn column = new TableColumn(rectangles, SWT.NONE);
	    column.setText(headers[i]);
	    column.setResizable(false);
	    column.setMoveable(false);
	    column.setWidth((width - 20) / headers.length);
	}
	bottom.setLayoutData(data);
/*
	rectangles.addMouseListener(new MouseAdapter() {
		@Override
		    public void mouseDown(MouseEvent e) {
		    Point click = new Point(e.x, e.y);
		    TableItem item = rectangles.getItem(click);
		    if (item != null) {
			selected_row = rectangles.indexOf(item);
			L.setText(item.getText(0));
			T.setText(item.getText(1));
			R.setText(item.getText(2));
			B.setText(item.getText(3));
		    }
		}
	    });

	if (can_edit) {
	    add.addSelectionListener(new SelectionAdapter() {
		    @Override
			public void widgetSelected(SelectionEvent e) {
			if (selected_row >= 0) {
			    TableItem item = new TableItem(rectangles, SWT.NONE);
			    String[] data_samples1 = new String[] { "", "", "", "",
								    "" };
			    item.setText(data_samples1);
			}
		    }
		});
	    del.addSelectionListener(new SelectionAdapter() {
		    @Override
			public void widgetSelected(SelectionEvent e) {
			if (selected_row >= 0) {
			    rectangles.remove(selected_row);
			    if (rectangles.getItemCount() == 0) {
				R.setText("");
				T.setText("");
				B.setText("");
				C.setText("");
				L.setText("");
			    }
			    selected_row = -1;
			}
		    }
		});
	}
*/
    }
/*
    @Override
	public void update(Observable o, Object arg) {
	rectangles.removeAll();
	c = new Compression(image.getImage());
	list = c.list;
	Iterator<MyRectangle> i = list.iterator();
	while (i.hasNext()) {
	    MyRectangle tmp = i.next();
	    TableItem item = new TableItem(rectangles, SWT.NONE);
	    item.setBackground(4, new Color(myShell.getDisplay(), tmp.C));
	    String[] dataItem = { tmp.L + "", tmp.T + "", tmp.R + "",
				  tmp.B + "" };
	    item.setText(dataItem);
	}
    }
*/
    public void update(Observable o, Object arg) {
        rectangles.removeAll();
        c = new Compression(image.getImage());
        list = c.list;
        String[] asd = new String[] {"a", "b", "c", "d", "e", "f", "g", "h", "i", "l", "m"};
        Iterator<MyRectangle> i = list.iterator();
        while (i.hasNext()) {
            MyRectangle tmp = i.next();
            TableItem item = new TableItem(rectangles, SWT.NONE);
            item.setBackground(4, new Color(myShell.getDisplay(), tmp.C));
            String[] dataItem = { asd[tmp.T] + "", (tmp.L+1) + "", asd[tmp.B] + "", (tmp.R+1) + "" };
            item.setText(dataItem);
        }
    }
}