package it.unimi.dsi.pixelmanipulator.views;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Observable;
import java.util.Observer;

import org.eclipse.swt.SWT;
//import org.eclipse.swt.custom.TableEditor;
//import org.eclipse.swt.events.FocusAdapter;
//import org.eclipse.swt.events.FocusEvent;
//import org.eclipse.swt.events.KeyAdapter;
//import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
//import org.eclipse.ui.internal.Model;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.utils.Compression;
import it.unimi.dsi.pixelmanipulator.utils.MyRectangle;

public class RectangleView extends View implements Observer {
    
    static int DEFAULT_WINDOW_HEIGHT = 600 ;
    
    private PixelModel image = null;
    Shell myShell = null;
    int selected_row = -1;
    Table rectangles;
    Compression c;
    boolean can_edit = false;
    ArrayList<MyRectangle> list;
    final int type_of_colors;
    final RGB[][] colors = new RGB[][] {
	new RGB[] { new RGB(255, 255, 255), new RGB(0, 0, 0) },
	new RGB[] { new RGB(255, 255, 255), new RGB(192, 192, 192),
		    new RGB(144, 144, 144), new RGB(96, 96, 96),
		    new RGB(48, 48, 48), new RGB(0, 0, 0) },
	new RGB[] { new RGB(255, 0, 0), new RGB(0, 255, 0),
		    new RGB(0, 0, 255), new RGB(0, 255, 255),
		    new RGB(255, 255, 0), new RGB(255, 0, 255) } };
    PixelController controller;

    public RectangleView(PixelModel new_image, Shell parent_Shell,
			 PixelController new_controller, int palette) {
	image = new_image;
	controller = new_controller;
	type_of_colors = palette;
	image.addObserver(this);
	myShell = new Shell(parent_Shell);
	myShell.setLayout(new GridLayout(1, false));
	myShell.setLocation(200,90);
	myShell.setText("Compressione rettangoli");
	initShell(DEFAULT_WINDOW_WIDTH, DEFAULT_WINDOW_HEIGHT);
	myShell.open();
    }

    public RectangleView(PixelModel new_image, Shell parent_Shell,
			 PixelController new_controller, int palette, boolean editable) {
	image = new_image;
	controller = new_controller;
	can_edit = editable;
	type_of_colors = palette;
	image.addObserver(this);
	myShell = new Shell(parent_Shell);
	myShell.setLayout(new GridLayout(1, false));
	myShell.setLocation(820,90);
	myShell.setText("Compressione rettangoli");
	if( editable ){
	    myShell.setBackground(new Color(null, new RGB(200,150,150)));
	}
	initShell(DEFAULT_WINDOW_WIDTH, DEFAULT_WINDOW_HEIGHT);
	myShell.open();
    }

    private void initShell(int width, int height) {
	GridData data = null;

	myShell.pack();
	myShell.setSize(width, height);

	Composite bottom = new Composite(myShell, SWT.FILL);
	data = new GridData();
	data.grabExcessHorizontalSpace = true;
	data.horizontalAlignment = GridData.FILL;
	data.verticalAlignment = GridData.FILL;
	data.grabExcessVerticalSpace = true;
	bottom.setLayout(new FillLayout());
	rectangles = new Table(bottom, SWT.FULL_SELECTION | SWT.FILL);
	rectangles.setHeaderVisible(true);
	String[] headers = new String[] { "X0", "Y0", "X1", "Y1", "Color" };
	//String[] headers = new String[] { "LT", "RB", "Color" };
	for (int i = 0; i < headers.length; i++) {
	    TableColumn column = new TableColumn(rectangles, SWT.NONE);
	    column.setText(headers[i]);
	    column.setResizable(false);
	    column.setMoveable(false);
	    column.setWidth((width - 20) / headers.length);
	}
	bottom.setLayoutData(data);

    }

    public void update(Observable o, Object arg) {
        rectangles.removeAll();
        c = new Compression(image.getImage());
        list = c.list;
        String[] asd = new String[] {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "m"};
        Iterator<MyRectangle> i = list.iterator();
        while (i.hasNext()) {
            MyRectangle tmp = i.next();
            TableItem item = new TableItem(rectangles, SWT.NONE);
            item.setBackground(4, new Color(myShell.getDisplay(), tmp.C));
            String[] dataItem = { (tmp.L) + "", asd[tmp.T] + "", (tmp.R) + "", asd[tmp.B] + "" };
            //String[] dataItem = { asd[tmp.T] + " - " + (tmp.L), asd[tmp.B] + " - " + (tmp.R) };
            item.setText(dataItem);
        }
    }
}
