package it.unimi.dsi.pixelmanipulator.views;

import java.util.Observable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Shell;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.model.PixelModel;
import it.unimi.dsi.pixelmanipulator.widgets.EditTable;


public class TableView extends View{
	final Shell shell;
	/**
	 * @uml.property  name="model"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	final PixelModel model;
	/**
	 * @uml.property  name="editTable"
	 * @uml.associationEnd  
	 */
	EditTable editTable = null;
	/**
	 * @uml.property  name="table"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	EditTable table;
	public TableView(Shell pShell, PixelModel pModel, boolean editable,PixelController new_controller, int palette) {
		model = pModel;
		shell = new Shell(pShell, SWT.TITLE);
		shell.setLayout(new FillLayout());
		shell.setText(editable?"Tabella modificabile":"Tabella non modificabile");
		initShell(500, 500);
		table = new EditTable(shell, editable, new_controller,palette);
		if( editable ){
			shell.setBackground(new Color(null, new RGB(200,150,150)));
		}
		shell.open();
		
	}

	private void initShell(int width, int height) {
		shell.pack();
		shell.setSize(width, height);
		shell.setLayout(new FillLayout());
	}

	@Override
	public void update(Observable arg0, Object arg1) {
		if(model.getImage() != null){
			table.init( model.getImage() );
		}
	}
}
