package it.unimi.dsi.pixelmanipulator.widgets;


import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;

import it.unimi.dsi.pixelmanipulator.controller.PixelController;
import it.unimi.dsi.pixelmanipulator.controller.Controller;

@SuppressWarnings("unused")
public class EditableCanvas extends Canvas {
	Image img;
	/**
	 * @uml.property  name="zoom"
	 */
	public int zoom = 0;
	/**
	 * @uml.property  name="last_x"
	 */
	int last_x = -1;
	/**
	 * @uml.property  name="last_y"
	 */
	int last_y = -1;
	/**
	 * @uml.property  name="record"
	 */
	boolean record = false;
	/**
	 * @uml.property  name="controller"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	private PixelController controller;
	private RGB[] colors;
	/**
	 * @uml.property  name="color"
	 */
	private int color;

	/**
	 * @param new_color
	 * @uml.property  name="color"
	 */
	public void setColor(int new_color) {
		color = new_color;
	}

	public EditableCanvas(Composite parent, int style, int zoom_new,
			Controller new_controller, int palette) {
		super(parent, style);
		switch (palette) {
		case PixelController.BW:
			colors = new RGB[] { new RGB(255, 255, 255), new RGB(0, 0, 0) };
			color = 0;
			break;
		case PixelController.GRAYSCALE:
			colors = new RGB[] { new RGB(255, 255, 255),
									new RGB(192, 192, 192), new RGB(144, 144, 144),
									new RGB(96, 96, 96), new RGB(48, 48, 48), new RGB(0, 0, 0) };
			color = 0;
			break;
		case PixelController.RGB6:
			colors = new RGB[] { new RGB(255, 0, 0), new RGB(0, 255, 0),
									new RGB(0, 0, 255), new RGB(0, 255, 255),
									new RGB(255, 255, 0), new RGB(255, 0, 255),
									new RGB(255, 255, 255), new RGB(0, 0, 0) };
			color = 0;
			break;
		default:
			break;
		}
		zoom = zoom_new;
		controller = (PixelController) new_controller;
//		this.addMouseMoveListener(new MouseMoveListener() {
//
//			@Override
//			public void mouseMove(MouseEvent evt) {
//				if (record) {
//					int x = (evt.x - (evt.x % zoom)) / zoom, y = (evt.y - (evt.y % zoom))
//							/ zoom;
//					controller.setPixel(x, y, colors[color]);
//				}
//			}
//		});
//		this.addMouseListener(new MouseListener() {
//
//			@Override
//			public void mouseUp(MouseEvent arg0) {
//				record = false;
//			}
//
//			@Override
//			public void mouseDown(MouseEvent evt) {
//				record = true;
//				int x = (evt.x - (evt.x % zoom)) / zoom, y = (evt.y - (evt.y % zoom))
//						/ zoom;
//				controller.setPixel(x, y, colors[color]);
//			}
//
//			@Override
//			public void mouseDoubleClick(MouseEvent arg0) {
//			}
//		});
		this.addPaintListener(new PaintListener() {

			@Override
			public void paintControl(PaintEvent evt) {
				if (img != null) {
					int gray = 215;
					evt.gc.drawImage(img, 0, 0);
					int width = img.getImageData().width, height = img
							.getImageData().height;
					for (int i = 0; i < width / zoom; i++) {
						evt.gc.setForeground(new Color(null, new RGB(gray,
								gray, gray)));
						evt.gc.drawLine(i * zoom, 0, i * zoom, height);
					}

					for (int i = 0; i < height / zoom; i++) {
						evt.gc.setForeground(new Color(null, new RGB(gray,
								gray, gray)));
						evt.gc.drawLine(0, i * zoom, width, i * zoom);
					}
				}

			}
		});
	}

	public void setImage(Image img_new) {
		img = img_new;
		redraw();
	}

}
